import YGOProDeck from '..';

const deck = new YGOProDeck();
deck.main.push(123);
deck.main.push(123);
deck.main.push(123);
deck.main.push(456);
deck.main.push(456);
deck.main.push(789);
deck.extra.push(1234);
deck.extra.push(5678);
deck.side.push(12345);

describe('Sample test.', () => {
  it('should encode and decode deck string', () => {
    const encoded = deck.toEncodedString();
    const buf = Buffer.from(
      encoded.replace(/[-_]/g, (m0) => (m0 == '-' ? '+' : '/')),
      'base64',
    );
    expect(buf.readUInt32LE(0) & 0xfffffff).toBe(123);
    expect((buf.readUInt32LE(0) >>> 28) & 0x3).toBe(0);
    expect(((buf.readUInt32LE(0) >>> 30) & 0x3) + 1).toBe(3);
    expect(buf.readUInt32LE(4) & 0xfffffff).toBe(456);
    expect((buf.readUInt32LE(4) >>> 28) & 0x3).toBe(0);
    expect(((buf.readUInt32LE(4) >>> 30) & 0x3) + 1).toBe(2);
    expect(buf.readUInt32LE(8) & 0xfffffff).toBe(789);
    expect((buf.readUInt32LE(8) >>> 28) & 0x3).toBe(0);
    expect(((buf.readUInt32LE(8) >>> 30) & 0x3) + 1).toBe(1);
    expect(buf.readUInt32LE(12) & 0xfffffff).toBe(1234);
    expect((buf.readUInt32LE(12) >>> 28) & 0x3).toBe(1);
    expect(((buf.readUInt32LE(12) >>> 30) & 0x3) + 1).toBe(1);
    expect(buf.readUInt32LE(16) & 0xfffffff).toBe(5678);
    expect((buf.readUInt32LE(16) >>> 28) & 0x3).toBe(1);
    expect(((buf.readUInt32LE(16) >>> 30) & 0x3) + 1).toBe(1);
    expect(buf.readUInt32LE(20) & 0xfffffff).toBe(12345);
    expect((buf.readUInt32LE(20) >>> 28) & 0x3).toBe(2);
    expect(((buf.readUInt32LE(20) >>> 30) & 0x3) + 1).toBe(1);
    expect(buf.length).toBe(24);
    const decoded = new YGOProDeck().fromEncodedString(encoded);
    expect(decoded.main).toStrictEqual(deck.main);
    expect(decoded.extra).toStrictEqual(deck.extra);
    expect(decoded.side).toStrictEqual(deck.side);
  });
  it('should encode and decode ydk text', () => {
    const ydk = deck.toYdkString();
    console.log(ydk);
    expect(ydk.split('\n')).toHaveLength(13);
    const decoded = new YGOProDeck().fromYdkString(ydk);
    expect(decoded.main).toStrictEqual(deck.main);
    expect(decoded.extra).toStrictEqual(deck.extra);
    expect(decoded.side).toStrictEqual(deck.side);
  })
});
